## vzlogger 0.8.6

=== CMakeLists.txt ===
# -*- mode: cmake; -*-
project(vzlogger)
cmake_minimum_required(VERSION 2.6.2 FATAL_ERROR)
if(POLICY CMP0011)
  cmake_policy(SET CMP0011 NEW)
endif(POLICY CMP0011)
# Supress a warning for if(GTest_FOUND)
IF(POLICY CMP0012)
    CMAKE_POLICY(SET CMP0012 NEW)
ENDIF()

set(VZLOGGER_MAJOR_VERSION 0)
set(VZLOGGER_MINOR_VERSION 8)
set(VZLOGGER_SUB_VERSION 6)
set(VERSION_SEP "-")
set(VZLOGGER_SHORT_VERSION "${VZLOGGER_MAJOR_VERSION}${VERSION_SEP}${VZLOGGER_MINOR_VERSION}")
set(VZLOGGER_VERSION "${VZLOGGER_SHORT_VERSION}${VERSION_SEP}${VZLOGGER_SUB_VERSION}")
set(VZLOGGER_RPM_VERSION "${VZLOGGER_MAJOR_VERSION}.${VZLOGGER_MINOR_VERSION}.${VZLOGGER_SUB_VERSION}")
set(VERSION_DATE "2018-08-04")
set(PACKAGE_STRING "${PROJECT_NAME} ${VZLOGGER_RPM_VERSION}")
set(VERSION "${VZLOGGER_RPM_VERSION}")
set(CMAKE_VERBOSE_MAKEFILE 1)

# debug build, on by default
ADD_DEFINITIONS(-g3)

###########################################################
# Where are the additional libraries installed? Note: provide includes
# path here, subsequent checks will resolve everything else
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/modules")

# get git sha1 as additional version:
include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_SHA1)
git_describe(GIT_SHALONG --always --abbrev=10 --long --all --dirty )
git_get_last_commit_date(GIT_LAST_COMMIT_DATE )

message("Compiling for target '${TARGET}'")
if( TARGET )
  if( ${TARGET} STREQUAL "ar71xx")
    include ( OpenWRT )
    message("Compiling for ar71xx")
    set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
    set(LINK_FLAGS_RELEASE "-static")
  endif( ${TARGET} STREQUAL "ar71xx")
else( TARGET )
  include ( CompilerFlags )
endif( TARGET )

include ( ConfigureMacro )

# options
OPTION(ENABLE_SML
  "enable support for smart messaging language (def=yes)])"
  On)
OPTION(ENABLE_OMS
  "enable support for OMS (M-Bus) based devices (def=yes)"
  On)
OPTION(ENABLE_LOCAL
  "enable support for local HTTPd (def=yes)]"
  On)
OPTION(ENABLE_MQTT
  "enable MQTT client support (def=yes)"
  On)
OPTION(WITH_READER
  "compile reader to for testing your meters (def=yes)])"
  On)
OPTION(ENABLE_OCR
	"enable support for OCR image/processing meter (def=off)"
	OFF)

OPTION(ENABLE_OCR_TESSERACT
	"enable support for OCR text recognition meter (def=off)"
	OFF)

OPTION(METEREXEC_ROOTACCESS
  "compile MeterExec protocol to use root privileges for script calls (def=no)])"
  Off)

OPTION(BUILD_TEST
  "build unit tests (def=on)])"
  On)

# find dependencies
# libsml
if( ENABLE_SML )
  include(FindSML)
  if(SML_FOUND)
    set(SML_SUPPORT 1)
    include_directories(${SML_INCLUDE_DIR})
  endif(SML_FOUND)
endif( ENABLE_SML )

if( ENABLE_OMS )
  # find dependencies todo libmbus
  include(FindMBus)
  include(FindOpenSSL)
  if(MBUS_FOUND)
    set(OMS_SUPPORT 1)
    include_directories(${MBUS_INCLUDE_DIR})
    set(OMS_LIBRARIES ${MBUS_LIBRARY})
  elseif(MBUS_FOUND)
    set(OMS_SUPPORT 0)
    message( STATUS "libmbus not found. Disabling ENABLE_OMS" )
  endif(MBUS_FOUND)

endif( ENABLE_OMS )

if(ENABLE_LOCAL)
  include(FindMicroHttpd)
  if(MICROHTTPD_FOUND)
    set(MICROHTTPD_SUPPORT 1)
    set(LOCAL_SUPPORT 1)
  endif(MICROHTTPD_FOUND)
endif(ENABLE_LOCAL)

if(ENABLE_MQTT)
  find_library(MQTT_LIBRARY mosquitto)
  find_path(MQTT_INCLUDE_DIR mosquitto.h)
  message( STATUS "search for libmosquitto returned ${MQTT_LIBRARY} and ${MQTT_INCLUDE_DIR}")
  if(MQTT_LIBRARY AND MQTT_INCLUDE_DIR)
    message( STATUS "libmosquitto found at ${MQTT_LIBRARY}")
    include_directories(${MQTT_INCLUDE_DIR})
  else()
    set(ENABLE_MQTT OFF)
    message( WARNING "libmosquitto not found. Disabled ENABLE_MQTT. Consider installing libmosquitto-dev package.")
  endif(MQTT_LIBRARY AND MQTT_INCLUDE_DIR)
else()
  message( STATUS "MQTT support disabled. If wanted use ENABLE_MQTT=On")
endif(ENABLE_MQTT)

if( ENABLE_OCR OR ENABLE_OCR_TESSERACT )
	include(FindLeptonica)
	if (NOT LEPTONICA_FOUND)
		message( STATUS "Leptonica not found. Disabling ENABLE_OCR" )
		set(ENABLE_OCR false)
		set(ENABLE_OCR_TESSERACT false)
	else ()
		message("OCR Meter enabled")
		# TODO install tesseract
		# and set include_directories appropriate
		if (ENABLE_OCR_TESSERACT)
			set(OCR_LIBRARIES ${LEPTONICA_LIBRARIES} tesseract)
			set(OCR_TESSERACT_SUPPORT 1)
		else ()
			set( OCR_LIBRARIES ${LEPTONICA_LIBRARIES})
		endif( ENABLE_OCR_TESSERACT)
		include_directories(${LEPTONICA_INCLUDE_DIRS})
		set(OCR_SUPPORT 1)
	endif( NOT LEPTONICA_FOUND )
endif( ENABLE_OCR OR ENABLE_OCR_TESSERACT )

IF(NOT WIN32)
  include(FindThreads)
ENDIF(NOT WIN32)

# libjson
include(FindJson)
if( NOT JSON_FOUND)
  message(FATAL_ERROR "libjson-c is required.
Install json-c or call cmake -DJSON_HOME=path_to_json_install")
endif( NOT JSON_FOUND)
include_directories(${JSON_INCLUDE_DIR})

# check for curl
IF(WIN32)
  add_definitions(-DCURL_STATICLIB)
  include(FindCURL_WIN32)
else(WIN32)
  #  add_definitions(-DCURL_STATICLIB)
  include(FindCURL)
  include(FindGnutls)
  include(FindOpenSSL) # needed by MySmartGrid API...
endif(WIN32)

find_library(LIBUUID uuid)
find_library(LIBGCRYPT gcrypt)

include_directories(${CMAKE_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR}/include)
include_directories(${CMAKE_SOURCE_DIR})

add_definitions(-DHAVE_CONFIG_HPP)
myconfigure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config.hpp.in
  ${CMAKE_CURRENT_BINARY_DIR}/config.hpp
  )

add_subdirectory(src)

find_package(Git)

if( BUILD_TEST )
	set(ENABLE_GOOGLEMOCK TRUE)
else()
	set(ENABLE_GOOGLEMOCK FALSE)
endif()

#disable unit tests on gcc4.6 (problems with googlemock 1.7)
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    # require at least gcc 4.8
    execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion
       OUTPUT_VARIABLE GOOGLETEST_GCC_COMPILER_VERSION)
# on travis-ci the CMAKE_CXX_COMPILER_VERSION is empty!    message(WARNING "Using compiler: ${CMAKE_CXX_COMPILER_VERSION} ${GOOGLETEST_GCC_COMPILER_VERSION}")
    if (GOOGLETEST_GCC_COMPILER_VERSION VERSION_LESS 4.8)
        message(WARNING "Disabled googlemock/-test tests due to GCC version < 4.8!")
	set(ENABLE_GOOGLEMOCK FALSE)
    endif()
endif()

# enable unit testing
include(CTest)
enable_testing()

if(ENABLE_GOOGLEMOCK)

  include(FindGTest)
  if (NOT GTest_FOUND AND GIT_FOUND) 
    # Download and unpack googletest at configure time
    configure_file(gtest/CMakeLists.txt.in gtest-download/CMakeLists.txt)
    execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
    RESULT_VARIABLE result
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/gtest-download )
    if(result)
        message(FATAL_ERROR "CMake step for googletest failed: ${result}")
    endif()
    execute_process(COMMAND ${CMAKE_COMMAND} --build .
    RESULT_VARIABLE result
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/gtest-download )
    if(result)
        message(FATAL_ERROR "Build step for googletest failed: ${result}")
    endif()
  
    # Prevent overriding the parent project's compiler/linker
    # settings on Windows
    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
  
    # Add googletest directly to our build. This defines
    # the gtest and gtest_main targets.
    add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/gtest-src
                     ${CMAKE_CURRENT_BINARY_DIR}/gtest-build
                     EXCLUDE_FROM_ALL)
  
    # The gtest/gtest_main targets carry header search path
    # dependencies automatically when using CMake 2.8.11 or
    # later. Otherwise we have to add them here ourselves.
    if (CMAKE_VERSION VERSION_LESS 2.8.11)
        include_directories("${gtest_SOURCE_DIR}/include")
        include_directories("${gmock_SOURCE_DIR}/include")
    endif()
  endif()

  add_subdirectory(tests)
endif()
if (ENABLE_GOOGLEMOCK AND NOT GTest_FOUND AND NOT GIT_FOUND)
  message(WARNING "googletest based unit tests disabled due to missing googletest or git. Please install one of those.")
endif(ENABLE_GOOGLEMOCK AND NOT GTest_FOUND AND NOT GIT_FOUND)
add_test(NAME vzlogger_unit_tests COMMAND vzlogger_unit_tests)

### print some output for the user
message("")
message("        ***** Configuration parameters *****")
message("             prefix: ${CMAKE_INSTALL_PREFIX}")
message("             json: -L${JSON_LIBRARY} -I${JSON_INCLUDE_DIR}")
if(SML_FOUND)
  message("             sml:  -L${SML_LIBRARY} -I${SML_INCLUDE_DIR}")
else(SML_FOUND)
  message("             sml: NOT FOUND")
endif(SML_FOUND)
if(MICROHTTPD_FOUND)
message("             microhttpd: -L${MICROHTTPD_LIBRARY} -I${MICROHTTPD_INCLUDE_DIR}")
endif(MICROHTTPD_FOUND)
if(ENABLE_MQTT)
  message("             mqtt: -L${MQTT_LIBRARY} -I${MQTT_INCLUDE_DIR}")
endif(ENABLE_MQTT)
if(METEREXEC_ROOTACCESS)
  message("             MeterExec: root privileges")
endif(METEREXEC_ROOTACCESS)
if(MBUS_FOUND)
message("             libmbus: -L${MBUS_LIBRARY} -I${MBUS_INCLUDE_DIR}")
endif(MBUS_FOUND)

if( ENABLE_SML AND NOT SML_FOUND)
  message(WARNING "libsml was not found.
Install libsml or call cmake -DSML_HOME=path_to_sml_install")
endif( ENABLE_SML AND NOT SML_FOUND)
if( ENABLE_LOCAL AND NOT MICROHTTPD_FOUND )
  message(WARNING "microhttpd was not found. Ignored ENABLE_LOCAL!
Install microhttpd or call cmake -DMICROHTTPD_HOME=path_to_microhttpd_install")
endif( ENABLE_LOCAL AND NOT MICROHTTPD_FOUND )

if( ENABLE_OMS AND NOT OMS_SUPPORT)
  message(WARNING "oms support not being enabled (libmbus not found)")
endif( ENABLE_OMS AND NOT OMS_SUPPORT)

# add clean-all target that removes the cached files from cmake as well (see e.g. issue #186)
add_custom_target(clean-all
    COMMAND ${CMAKE_BUILD_TOOL} clean
    COMMAND ${CMAKE_COMMAND} -P clean-all-cmake.txt
)

# CPACK packaging
INCLUDE(InstallRequiredSystemLibraries)
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS On)
#set(CPACK_SOURCE_GENERATOR "TGZ;TBZ2;PKG")
set(CPACK_SOURCE_GENERATOR "TGZ;TBZ2")

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "volkszaehler.org ist ein freies Smart Meter (hier: intelligenter Stromzähler) im Selbstbau.")
set(CPACK_PACKAGE_VENDOR              "Steffen Vogel")
set(CPACK_PACKAGE_CONTACT             "Steffen Vogel <info@steffenvogel.de>")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER   "Steffen Vogel <info@steffenvogel.de>")
set(CPACK_PACKAGE_DESCRIPTION_FILE    "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_VERSION_MAJOR ${VZLOGGER_MAJOR_VERSION})
set(CPACK_PACKAGE_VERSION_MINOR ${VZLOGGER_MINOR_VERSION})
set(CPACK_PACKAGE_VERSION_PATCH ${VZLOGGER_SUB_VERSION})
set(CPACK_PACKAGE_INSTALL_DIRECTORY "${PROJECT_NAME}-${VZLOGGER_MAJOR_VERSION}.${VZLOGGER_MINOR_VERSION}")

set(CPACK_SOURCE_IGNORE_FILES "/CVS/;/.svn/;.swp$;.#;/#;.*~;cscope.*;build.*")

IF(WIN32 AND NOT UNIX)
  set(CPACK_GENERATOR "NSIS")
  set(CPACK_NSIS_PACKAGE_NAME "Gridlicense Demo Tools")
  # set(CPACK_PACKAGE_EXECUTABLES "gui4" "Grid License Demo Frontend")
  set(CPACK_PACKAGE_DEFAULT_LOCATION ${INSTALL_DIR})

  # sure there is at least one set of four (4) backlasshes.
  set(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\vzlogger.exe")
  set(CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_INSTALL_DIRECTORY} VZlogger")
  set(CPACK_NSIS_HELP_LINK    "http://volkszaehler.org/")
  set(CPACK_NSIS_URL_INFO_ABOUT "http://wiki.volkszaehler.org/software/controller/vzlogger")
  set(CPACK_NSIS_CONTACT "Steffen Vogel <info@steffenvogel.de>")
  set(CPACK_NSIS_MODIFY_PATH ON)
  # set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "${CMAKE_PROJECT_NAME}-${EWS_VERSION}")
  # set(CPACK_NSIS_MENU_LINKS "${EWS_WEBSITE}" "Homepage for ${EWS_APP_NAME}")
  set(CPACK_NSIS_DEFINES "  !define MUI_WELCOMEPAGE_TITLE_3LINES 1
    !define MUI_FINISHPAGE_TITLE_3LINES 1")
else(WIN32 AND NOT UNIX)
  #set(CPACK_SET_DESTDIR On)
  set(CPACK_SOURCE_STRIP_FILES "")
  set(CPACK_GENERATOR "TGZ;TBZ2;TZ;DEB;RPM")
  set(CPACK_RPM_PACKAGE_RELOCATABLE 1)
  set(CPACK_SYSTEM_NAME ${CMAKE_HOST_SYSTEM_PROCESSOR})
endif(WIN32 AND NOT UNIX)
include(CPack)

=== debian/changelog ===
vzlogger (0.8.6-2) unstable; urgency=medium

  * Added patch that removes an assert for a time duration (Closes: #1071728) 

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Sat, 25 May 2024 07:41:06 +0200

vzlogger (0.8.6-1) unstable; urgency=medium

  * New upstream release (Closes: #1070430)
  * Fixed passing of hardening flags to cmake 
  * Bumped Standards-Version to 4.7.0
  * Fixed several Lintian info level issues
  * Moved configuration change from git to quilt patch 

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Fri, 17 May 2024 06:32:32 +0200

vzlogger (0.8.3-1) unstable; urgency=medium

  * Initial upload (Closes: #864255) 

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Mon, 04 Mar 2024 19:03:44 +0100

=== debian/control ===
Source: vzlogger
Section: net
Priority: optional
Maintainer: Joachim Zobel <jz-2017@heute-morgen.de>
Build-Depends: debhelper-compat (= 13),
 pkgconf,
 libjson-c-dev,
 libcurl4-openssl-dev,
 libmicrohttpd-dev (>= 0.4.6),
 libsml-dev (>= 1.0),
 cmake,
 libsasl2-dev,
 libssl-dev (>= 3.0),
 libgcrypt-dev,
 libgnutls28-dev,
 uuid-dev,
 libunistring-dev,
 libgmock-dev,
 libgtest-dev,
 pandoc,
 libmosquitto-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: http://wiki.volkszaehler.org/software/controller/vzlogger
Vcs-Git: https://github.com/volkszaehler/vzlogger.git -b debian
Vcs-Browser: https://github.com/volkszaehler/vzlogger/tree/debian

Package: vzlogger
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Pre-Depends: ${misc:Pre-Depends}
Description: program for logging measurements to a volkszaehler.org middleware
 vzlogger...
  * is a tool to read and log measurements of a wide variety of smartmeters and
    sensors to the volkszaehler.org middleware.
  * can run as a daemon or via Cron.
  * includes a tiny onboard httpd to serve
    realtime readings to the AJAX web frontend.
  * is written in C++.

=== debian/watch ===
version=4
https://github.com/volkszaehler/vzlogger/tags .*/v?(\d.*)@ARCHIVE_EXT@

## vzlogger 0.8.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 # -*- mode: cmake; -*-
+# CMake 4 won't build without
+cmake_minimum_required(VERSION 3.5)
 project(vzlogger)
-cmake_minimum_required(VERSION 2.6.2 FATAL_ERROR)
 if(POLICY CMP0011)
   cmake_policy(SET CMP0011 NEW)
 endif(POLICY CMP0011)
@@ -11,7 +12,7 @@
 
 set(VZLOGGER_MAJOR_VERSION 0)
 set(VZLOGGER_MINOR_VERSION 8)
-set(VZLOGGER_SUB_VERSION 6)
+set(VZLOGGER_SUB_VERSION 9)
 set(VERSION_SEP "-")
 set(VZLOGGER_SHORT_VERSION "${VZLOGGER_MAJOR_VERSION}${VERSION_SEP}${VZLOGGER_MINOR_VERSION}")
 set(VZLOGGER_VERSION "${VZLOGGER_SHORT_VERSION}${VERSION_SEP}${VZLOGGER_SUB_VERSION}")

=== src/CMakeLists.txt ===
# -*- mode: cmake; -*-

#AM_CFLAGS = -Wall -D_REENTRANT -std=gnu99 $(DEPS_VZ_CFLAGS)
#AM_CPPFLAGS = -I $(top_srcdir)/include
#AM_LDFLAGS =

add_subdirectory(api)
add_subdirectory(protocols)

## local interface support
#####################################################################
if(LOCAL_SUPPORT)
  set(local_srcs local.cpp)
  include_directories(${MICROHTTPD_INCLUDE_DIR})
else(LOCAL_SUPPORT)
  set(local_srcs "")
endif(LOCAL_SUPPORT)

if(ENABLE_MQTT)
  set(mqtt_srcs mqtt.cpp)
else(ENABLE_MQTT)
  set(mqtt_srcs "")
endif(ENABLE_MQTT)

configure_file("${CMAKE_SOURCE_DIR}/src/gitSha1.cpp.in" "${CMAKE_BINARY_DIR}/gitSha1.cpp" @ONLY)

set(vzlogger_srcs
  vzlogger.cpp
  ltqnorm.cpp
  Meter.cpp
  ${CMAKE_BINARY_DIR}/gitSha1.cpp
  CurlSessionProvider.cpp
  PushData.cpp ../include/PushData.hpp
)

set(libvz_srcs
  Channel.cpp
  Config_Options.cpp
  threads.cpp
  Buffer.cpp
  Obis.cpp
  Options.cpp
  Reading.cpp
  exception.cpp
  ${local_srcs}
  ${mqtt_srcs}
  MeterMap.cpp
  )

add_library(vz ${libvz_srcs})

add_executable(vzlogger ${vzlogger_srcs})

target_link_libraries(vzlogger proto vz vz-api)
target_link_libraries(vzlogger ${JSON_LIBRARY})
if(SML_FOUND)
  target_link_libraries(vzlogger ${SML_LIBRARY})
endif(SML_FOUND)
if( MBUS_FOUND )
    target_link_libraries(vzlogger ${MBUS_LIBRARY})
endif( MBUS_FOUND )
target_link_libraries(vzlogger ${OCR_LIBRARIES})

if(LOCAL_SUPPORT)
target_link_libraries(vzlogger ${MICROHTTPD_LIBRARY})
endif(LOCAL_SUPPORT)

if(ENABLE_MQTT)
target_link_libraries(vzlogger ${MQTT_LIBRARY})
endif(ENABLE_MQTT)

target_link_libraries(vzlogger ${LIBGCRYPT})
target_link_libraries(vzlogger pthread m ${LIBUUID})
target_link_libraries(vzlogger dl)
if( TARGET )
  if( ${TARGET} STREQUAL "ar71xx")
    set_target_properties(vzlogger PROPERTIES LINK_FLAGS "-static")
    target_link_libraries(vzlogger ${OPENWRT_TARGET_DIR}/usr/lib/libssl.a)
    target_link_libraries(vzlogger ${OPENWRT_TARGET_DIR}/usr/lib/libcrypto.a)
    target_link_libraries(vzlogger ${OPENWRT_TARGET_DIR}/usr/lib/libz.a)
    target_link_libraries(vzlogger dl)
  endif( ${TARGET} STREQUAL "ar71xx")
endif( TARGET )
target_link_libraries(vzlogger ${CURL_STATIC_LIBRARIES} ${CURL_LIBRARIES} unistring ${GNUTLS_LIBRARIES} ${OPENSSL_LIBRARIES} )

# add programs to the install target
INSTALL(PROGRAMS
  ${CMAKE_CURRENT_BINARY_DIR}/vzlogger
  DESTINATION bin)
install(TARGETS vz
	ARCHIVE DESTINATION lib/static COMPONENT libraries
	LIBRARY DESTINATION lib COMPONENT libraries)

=== tests/CMakeLists.txt ===

# all *.cpp files here will be used.
file(GLOB test_sources *.cpp)

# add required source files
list(APPEND test_sources
    ../src/Buffer.cpp
    ../src/Channel.cpp
    ../src/Config_Options.cpp
    ../src/api/Volkszaehler.cpp
    ../src/CurlSessionProvider.cpp
    ../src/protocols/MeterW1therm.cpp
    ../src/api/hmac.cpp
)

set(test_libraries
    gtest
    gmock
    ${JSON_LIBRARY}
    ${LIBUUID}
    dl
    pthread
    ${CURL_STATIC_LIBRARIES}
    ${CURL_LIBRARIES}
    unistring
    ${GNUTLS_LIBRARIES}
    ${OCR_LIBRARIES}
    ${OPENSSL_LIBRARIES}
)

if(SML_FOUND AND ENABLE_SML)
    list(APPEND test_sources ../src/protocols/MeterSML.cpp)
    list(APPEND test_libraries ${SML_LIBRARY})
else(SML_FOUND AND ENABLE_SML)
    list(REMOVE_ITEM test_sources ${CMAKE_CURRENT_SOURCE_DIR}/MeterSML.cpp)
endif(SML_FOUND AND ENABLE_SML)

if(OCR_SUPPORT)
    list(APPEND test_sources ../src/protocols/MeterOCR.cpp)
else(OCR_SUPPORT)
    list(REMOVE_ITEM test_sources ${CMAKE_CURRENT_SOURCE_DIR}/ut_MeterOCR.cpp)
endif(OCR_SUPPORT)

if(OCR_TESSERACT_SUPPORT)
    list(APPEND test_sources ../src/protocols/MeterOCR.cpp)
else(OCR_TESSERACT_SUPPORT)
    list(REMOVE_ITEM test_sources
        ${CMAKE_CURRENT_SOURCE_DIR}/ut_MeterOCRTesseract.cpp)
endif(OCR_TESSERACT_SUPPORT)

if(ENABLE_MQTT)
    list(APPEND test_sources ../src/mqtt.cpp)
    list(APPEND test_libraries ${MQTT_LIBRARY})
endif(ENABLE_MQTT)

if(OMS_SUPPORT)
    list(APPEND test_sources ../src/protocols/MeterOMS.cpp)
    list(APPEND test_libraries ${MBUS_LIBRARY})
endif(OMS_SUPPORT)

add_executable(vzlogger_unit_tests ${test_sources})
target_link_libraries(vzlogger_unit_tests ${test_libraries})

configure_file(include/test_config.hpp.in include/test_config.hpp)
target_include_directories(vzlogger_unit_tests
    PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/include
)


set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")

add_subdirectory(mocks)

FIND_PROGRAM(GCOV_PATH gcov)
FIND_PROGRAM(LCOV_PATH lcov)
FIND_PROGRAM(GENHTML_PATH genhtml)

IF(GCOV_PATH AND LCOV_PATH AND GENHTML_PATH)
    MESSAGE("gcov found. Adding target test_coverage ...")

    # Setup target for coverage
    # we need to add each single test binary into the command list

    ADD_CUSTOM_TARGET(test_coverage
        # Cleanup lcov
        ${LCOV_PATH} --rc lcov_branch_coverage=1 --directory . --zerocounters
        # Run tests
        COMMAND vzlogger_unit_tests
        COMMAND mock_metermap
        COMMAND mock_MeterW1therm
        COMMAND mock_MeterOMS
        COMMAND mock_MeterS0

        # Capturing lcov counters and generating report
        COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --directory . --capture --output-file coverage.info
        COMMAND ${LCOV_PATH} --rc lcov_branch_coverage=1 --remove coverage.info 'tests/*' '/usr/*' --output-file coverage.info.cleaned
        COMMAND ${GENHTML_PATH} --rc lcov_branch_coverage=1 -o coverage coverage.info.cleaned
        COMMAND ${CMAKE_COMMAND} -E remove coverage.info coverage.info.cleaned

        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        COMMENT "Resetting code coverage counters to zero.\nProcessing code coverage counters and generating report."
    )

    # Show info where to find the report
    ADD_CUSTOM_COMMAND(TARGET test_coverage POST_BUILD
        COMMAND ;
        COMMENT "Open ./coverage/index.html in your browser to view the coverage report."
    )

ENDIF(GCOV_PATH AND LCOV_PATH AND GENHTML_PATH)

=== src/api/CMakeLists.txt ===
# -*- mode: cmake; -*-


set(api_srcs
  Volkszaehler.cpp
  MySmartGrid.cpp
  InfluxDB.cpp
  Null.cpp
  CurlIF.cpp
  CurlCallback.cpp
  CurlResponse.cpp
  hmac.cpp
)

add_library(vz-api ${api_srcs})
install(TARGETS vz-api
	ARCHIVE DESTINATION lib/static COMPONENT libraries
	LIBRARY DESTINATION lib COMPONENT libraries)

=== src/protocols/CMakeLists.txt ===
# -*- mode: cmake; -*-

# SML support
#####################################################################
if( SML_SUPPORT )
  set(sml_srcs MeterSML.cpp)
else( SML_SUPPORT )
  set(sml_srcs "")
endif( SML_SUPPORT )

if( OCR_TESSERACT_SUPPORT )
  set(ocr_srcs MeterOCR.cpp MeterOCRTesseract.cpp)
else ()
    if (OCR_SUPPORT)
        set(ocr_srcs MeterOCR.cpp)
    else ()
        set(ocr_srcs "")
    endif (OCR_SUPPORT)
endif( OCR_TESSERACT_SUPPORT )

if( OMS_SUPPORT )
  set(oms_srcs MeterOMS.cpp ../../include/protocols/MeterOMS.hpp)
else ( OMS_SUPPORT )
  set(oms_srcs "")
endif( OMS_SUPPORT )

set(proto_srcs
  MeterS0.cpp ../../include/protocols/MeterS0.hpp
  MeterD0.cpp ../../include/protocols/MeterD0.hpp
  ${sml_srcs}
  MeterFluksoV2.cpp
  ${ocr_srcs}
  MeterFile.cpp
  MeterExec.cpp
  MeterRandom.cpp
  MeterW1therm.cpp ../../include/protocols/MeterW1therm.hpp
  ${oms_srcs}
)

add_library(proto ${proto_srcs})
install(TARGETS proto
	LIBRARY DESTINATION lib COMPONENT libraries
	ARCHIVE DESTINATION lib/static COMPONENT libraries)

=== tests/mocks/CMakeLists.txt ===
include_directories(BEFORE .)

if(LOCAL_SUPPORT)
    set(mock_local_srcs ../../src/local.cpp)
endif(LOCAL_SUPPORT)

if(ENABLE_MQTT)
	set(mock_mqtt_sources ../../src/mqtt.cpp)
else(ENABLE_MQTT)
	set(mock_mqtt_sources "")
endif(ENABLE_MQTT)

if(OMS_SUPPORT)
    set(mock_oms_sources ../../src/protocols/MeterOMS.cpp)
elseif( OMS_SUPPORT )
    set(mock_oms_sources "")
endif( OMS_SUPPORT )

if(SML_FOUND)
    set(mock_sml_sources ../../src/protocols/MeterSML.cpp)
elseif(SML_FOUND)
    set(mock_sml_sources "")
endif(SML_FOUND)

add_executable(mock_metermap
    mock_metermap.cpp
    ../../src/Meter.cpp
    ../../src/Options.cpp
	../../src/protocols/MeterD0.cpp
	../../src/protocols/MeterFile.cpp
	../../src/protocols/MeterExec.cpp
	../../src/protocols/MeterS0.cpp
	../../src/protocols/MeterRandom.cpp
	${mock_sml_sources}
	../../src/protocols/MeterFluksoV2.cpp
	../../src/protocols/MeterW1therm.cpp
	../../src/Reading.cpp
	../../src/Obis.cpp
	../../src/ltqnorm.cpp
	../../src/MeterMap.cpp
	../../src/threads.cpp
	../../src/api/hmac.cpp
	../../src/Config_Options.cpp
	../../src/Buffer.cpp
	../../src/api/Volkszaehler.cpp
	../../src/api/MySmartGrid.cpp
	../../src/api/InfluxDB.cpp
	../../src/api/Null.cpp
	../../src/api/CurlIF.cpp
	../../src/api/CurlCallback.cpp
	../../src/api/CurlResponse.cpp
	protocols/MeterOCR.hpp
	Channel.hpp
	../../src/CurlSessionProvider.cpp
	../../src/PushData.cpp
	${mock_local_srcs}
	${mock_oms_sources}
	${mock_mqtt_sources}
)

target_link_libraries(mock_metermap ${CURL_STATIC_LIBRARIES} ${CURL_LIBRARIES})

if (MICROHTTPD_FOUND)
    target_link_libraries(mock_metermap ${MICROHTTPD_LIBRARY})
endif(MICROHTTPD_FOUND)

target_link_libraries(mock_metermap unistring ${GNUTLS_LIBRARIES} ${OPENSSL_LIBRARIES})
target_link_libraries(mock_metermap
    gtest
    gmock
    pthread
    ${JSON_LIBRARY}
    ${LIBUUID}
    dl
)
if(SML_FOUND)
    target_link_libraries(mock_metermap ${SML_LIBRARY})
endif(SML_FOUND)
if(MBUS_FOUND)
    target_link_libraries(mock_metermap ${MBUS_LIBRARY})
endif(MBUS_FOUND)
if(ENABLE_MQTT)
	target_link_libraries(mock_metermap ${MQTT_LIBRARY})
endif(ENABLE_MQTT)


add_executable(mock_MeterW1therm
    mock_MeterW1therm.cpp
    ../../src/protocols/MeterW1therm.cpp
    ../../src/Reading.cpp
    ../../src/Obis.cpp
    ../../src/Options.cpp
)

target_link_libraries(mock_MeterW1therm
    gtest
    gmock
    pthread
    ${JSON_LIBRARY}
    ${LIBUUID}
    dl
)

add_test(mock_metermap mock_metermap)
add_test(mock_MeterW1therm mock_MeterW1therm)

if(OMS_SUPPORT)
add_executable(mock_MeterOMS
	mock_MeterOMS.cpp
	../../src/protocols/MeterOMS.cpp
	../../src/Reading.cpp
	../../src/Obis.cpp
	../../src/Options.cpp
)

target_link_libraries(mock_MeterOMS
    gtest
    gmock
    pthread
    ${JSON_LIBRARY}
    ${LIBUUID}
    ${MBUS_LIBRARY}
    ${OPENSSL_LIBRARIES}
    dl
)
add_test(mock_MeterOMS mock_MeterOMS)

endif(OMS_SUPPORT)

add_executable(mock_MeterS0
	mock_MeterS0.cpp
	../../src/protocols/MeterS0.cpp
	../../src/Reading.cpp
	../../src/Obis.cpp
	../../src/Options.cpp
)

target_link_libraries(mock_MeterS0
    gtest
    gmock
    pthread
    ${JSON_LIBRARY}
    ${LIBUUID}
    dl
)
add_test(mock_MeterS0 mock_MeterS0)

# ensure that all test binaries are added to tests/CMakeLists.txt test_coverage target
# (or find a better way to add them from here to the test_coverage target

=== debian/changelog ===
vzlogger (0.8.9-1) unstable; urgency=medium

  * New upstream release (Closes: #1113626, #1114439)
  * Migrated watch file to version 5
  * d/vzlogger.postinst: Compatibility fix to have bullseye accept usernames 
    with underscore

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Thu, 02 Oct 2025 05:48:53 +0200

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  libgtest-dev,
  pandoc,
  libmosquitto-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: http://wiki.volkszaehler.org/software/controller/vzlogger
 Vcs-Git: https://github.com/volkszaehler/vzlogger.git -b debian

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
# Debian flags invented usage of LTO, which in combination with google test on
# Ubuntu 22.04.4 causes the errors supressed below
export CXXFLAGS += -Wno-lto-type-mismatch -Wno-odr

VERSION1=$(shell echo ${DEB_VERSION_UPSTREAM} | cut -f1 -d.)
VERSION2=$(shell echo ${DEB_VERSION_UPSTREAM} | cut -f2 -d.)
VERSION3=$(shell echo ${DEB_VERSION_UPSTREAM} | cut -f3 -d.)

execute_before_dh_auto_configure:
	sed -i "s#set(VZLOGGER_MAJOR_VERSION.*)#set(VZLOGGER_MAJOR_VERSION ${VERSION1})#" CMakeLists.txt
	sed -i "s#set(VZLOGGER_MINOR_VERSION.*)#set(VZLOGGER_MINOR_VERSION ${VERSION2})#" CMakeLists.txt
	sed -i "s#set(VZLOGGER_SUB_VERSION.*)#set(VZLOGGER_SUB_VERSION ${VERSION3})#" CMakeLists.txt

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TEST=off
endif

override_dh_installsystemd:
	# stop the service during install, see man dh_installsystemd
	dh_installsystemd --no-restart-after-upgrade

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test: ;
endif

execute_after_dh_auto_build:
	pandoc -o vzlogger.8 -s -t man debian/vzlogger.8.md

%:
	dh $@

=== debian/watch ===
Version: 5

Source: https://github.com/volkszaehler/vzlogger/tags
Matching-Pattern: .*/v?(\d.*)@ARCHIVE_EXT@
